#region Copyright (C) 2003-2010 Stimulsoft
/*
{*******************************************************************}
{																	}
{	Stimulsoft Reports       										}
{																	}
{	Copyright (C) 2003-2010 Stimulsoft     							}
{	ALL RIGHTS RESERVED												}
{																	}
{	The entire contents of this file is protected by U.S. and		}
{	International Copyright Laws. Unauthorized reproduction,		}
{	reverse-engineering, and distribution of all or any portion of	}
{	the code contained in this file is strictly prohibited and may	}
{	result in severe civil and criminal penalties and will be		}
{	prosecuted to the maximum extent possible under the law.		}
{																	}
{	RESTRICTIONS													}
{																	}
{	THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES			}
{	ARE CONFIDENTIAL AND PROPRIETARY								}
{	TRADE SECRETS OF Stimulsoft										}
{																	}
{	CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON		}
{	ADDITIONAL RESTRICTIONS.										}
{																	}
{*******************************************************************}
*/
#endregion Copyright (C) 2003-2010 Stimulsoft

using System;
using System.Windows.Forms;
using System.ComponentModel;
using Stimulsoft.Base.Localization;
using Stimulsoft.Base.Serializing;
using Stimulsoft.Report.Dictionary.Design;

namespace Stimulsoft.Report.Dictionary
{
	[TypeConverter(typeof(StiSqlDatabaseConverter))]
	public class StiSQLiteDatabase : StiSqlDatabase
	{
		#region StiService override
		public override string ServiceName
		{
			get
            {
                return StiLocalization.Get("Database", "DatabaseSQLite");
			}
		}
		#endregion

		#region DataAdapter override
		protected override string DataAdapterType
		{
			get
			{
				return "Stimulsoft.Report.Dictionary.StiSQLiteAdapterService";
			}
		}
		#endregion

		public override DialogResult Edit(bool newDatabase)
        {

            #region for WinForms
            using (StiSqlDatabaseEditForm form = new StiSqlDatabaseEditForm(this))
            {
                if (newDatabase) form.Text = StiLocalization.Get("FormDatabaseEdit", "SQLiteNew");
                else form.Text = StiLocalization.Get("FormDatabaseEdit", "SQLiteEdit");

                form.tbName.Text = this.Name;
                form.tbAlias.Text = this.Alias;
                form.tbConnectionString.Text = this.ConnectionString;
                if (form.ShowDialog() == DialogResult.OK)
                {
                    this.Name = form.tbName.Text;
                    this.Alias = form.tbAlias.Text;
                    this.ConnectionString = form.tbConnectionString.Text;
                }
                return form.DialogResult;
            }
            #endregion
            
            #region for WPF
            //StiSqlDatabaseEditWindow form = new StiSqlDatabaseEditWindow(this);
            //{
            //    if (newDatabase) form.Title = StiLocalization.Get("FormDatabaseEdit", "SQLiteNew");
            //    else form.Title = StiLocalization.Get("FormDatabaseEdit", "SQLiteEdit");

            //    form.TbName.Text = this.Name;
            //    form.TbAlias.Text = this.Alias;
            //    form.TbConnectionString.Text = this.ConnectionString;
            //    if (form.ShowDialog() == true)
            //    {
            //        this.Name = form.TbName.Text;
            //        this.Alias = form.TbAlias.Text;
            //        this.ConnectionString = form.TbConnectionString.Text;
            //        return DialogResult.OK;
            //    }
            //    return DialogResult.Cancel;
            //}
            #endregion

        }
	
		/// <summary>
        /// Creates a new object of the type StiSQLiteDatabase.
		/// </summary>
        public StiSQLiteDatabase()
            : this(string.Empty, string.Empty)
		{
		}


		/// <summary>
        /// Creates a new object of the type StiSQLiteDatabase.
		/// </summary>
        public StiSQLiteDatabase(string name, string connectionString)
            : base(name, connectionString)
        {
        }
		

		/// <summary>
        /// Creates a new object of the type StiSQLiteDatabase.
		/// </summary>
        public StiSQLiteDatabase(string name, string alias, string connectionString)
            : base(name, alias, connectionString)
        {
        }


        /// <summary>
		/// Creates a new object of the type StiSQLiteDatabase.
		/// </summary>
		public StiSQLiteDatabase(string name, string alias, string connectionString, bool promptUserNameAndpassword) :
            base(name, alias, connectionString, promptUserNameAndpassword)
		{
		}	

	}
}
